<?php
namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\BillingComparisonService;
use SM\Traits\TResponse;

class BillingComparisonController extends SMCrud
{
    use TResponse;

    protected $BillingComparisonService;

    public function __construct($crudService, $environment, BillingComparisonService $BillingComparisonService) {
        parent::__construct($crudService, $environment);
        $this->BillingComparisonService = $BillingComparisonService;
    }

    /*public function getBillingComparison(Request $request, Response $response){

        $grid = $this->BillingComparisonService->getBillingComparison($request->getParameters());
        $dtsVal = new DataSet('grid', $grid);
        $response->addDataSet($dtsVal);
    }*/

    public function getBillingComparison(Request $request, Response $response) {
        try {
            $data = $this->BillingComparisonService->getBillingComparison(
                $request->getParameters()
            );
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(
                ["error" => $ex->getMessage(), "code" => $ex->getCode()],
                500
            );
        }
    }

    public function getContractsBillingComparison(Request $request, Response $response) {
        try {
            $data = $this->BillingComparisonService->getContractsBillingComparison();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(
                ["error" => $ex->getMessage(), "code" => $ex->getCode()],
                500
            );
        }
    }

    public function getBusinessPartnersBilling(Request $request, Response $response) {
        try {
            $data = $this->BillingComparisonService->getBusinessPartnersBilling();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(
                ["error" => $ex->getMessage(), "code" => $ex->getCode()],
                500
            );
        }
    }

    public function getBillingScopes(Request $request, Response $response) {
        try {
            $data = $this->BillingComparisonService->getBillingScopes();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(
                ["error" => $ex->getMessage(), "code" => $ex->getCode()],
                500
            );
        }
    }

    public function billingComparisonOfTheParcelTab(Request $request, Response $response) {
        try {
            $data = $this->BillingComparisonService->billingComparisonOfTheParcelTab(
                $request->getParameters()
            );
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(
                ["error" => $ex->getMessage(), "code" => $ex->getCode()],
                500
            );
        }
    }

    public function billingComparisonOfMeasurementItems(Request $request, Response $response) {
        try {
            $data = $this->BillingComparisonService->billingComparisonOfMeasurementItems(
                $request->getParameters()
            );
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(
                ["error" => $ex->getMessage(), "code" => $ex->getCode()],
                500
            );
        }
    }

    public function billingComparisonOfVariableMeasures(Request $request, Response $response) {
        try {
            $data = $this->BillingComparisonService->billingComparisonOfVariableMeasures(
                $request->getParameters()
            );
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(
                ["error" => $ex->getMessage(), "code" => $ex->getCode()],
                500
            );
        }
    }
}
?>
