<?php
namespace SM\Controller;

use Zeedhi\Framework\DTO\Request;
use SM\Service\Sm00037000MotivoNegociacaoService;
use SM\Traits\TResponse;

class Sm00037000MotivoNegociacaoController {

    use TResponse;

    protected $motivoNegociacaoService;

    public function __construct(Sm00037000MotivoNegociacaoService $motivoNegociacaoService) {
        $this->motivoNegociacaoService = $motivoNegociacaoService;
    }

    public function getMotivos() {
        try {
            $data = $this->motivoNegociacaoService->getMotivos();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function salvarMotivos(Request $request) {
        try {
            $params = $request->getParameters();
            $this->motivoNegociacaoService->salvarMotivos($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function excluirMotivos(Request $request) {
        try {
            $params = $request->getParameters();
            $this->motivoNegociacaoService->excluirMotivos($params);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
