<?php
namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\Sm00054001ReducaoQuantidadeMedidaOperadorService;
use SM\Traits\TResponse;

class Sm00054001ReducaoQuantidadeMedidaOperadorController extends SMCrud {

    use TResponse;

    protected $Sm00054001ReducaoQuantidadeMedidaOperadorService;

    public function __construct($crudService, $environment, Sm00054001ReducaoQuantidadeMedidaOperadorService $Sm00054001ReducaoQuantidadeMedidaOperadorService) {
            parent::__construct($crudService, $environment);
            $this->Sm00054001ReducaoQuantidadeMedidaOperadorService = $Sm00054001ReducaoQuantidadeMedidaOperadorService;
    }

    public function getReducaoQuantidadeMedidaOperador(Request $request, Response $response) {
        try {
                $data = $this->Sm00054001ReducaoQuantidadeMedidaOperadorService->getReducaoQuantidadeMedidaOperador();
                $this->sendResponse($data, 200);
            } catch (\Exception $ex) {
                $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
            }
    }
   
    public function inserirReducaoQuantidadeMedidaOperador(DTO\Request $request, DTO\Response $response){
        try {
            $this->Sm00054001ReducaoQuantidadeMedidaOperadorService->inserirReducaoQuantidadeMedidaOperador($request->getParameters());
        }
        catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
    
    public function deletarReducaoQuantidadeMedidaOperador(DTO\Request $request, DTO\Response $response){
        try {
            $this->Sm00054001ReducaoQuantidadeMedidaOperadorService->deletarReducaoQuantidadeMedidaOperador($request->getParameters());
        }
        catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}