<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class Sm00034001DescontoPeriodoCarenciaOperadorFactory {
    
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getDescontoPeriodoCarenciaOperador()
    {
        $sql = "SELECT  CA.NRCARENCIAOPER,
                        CA.NRPARCNEGOCIO,
                        CA.NRDAISMAXCARENCIA,
                        CA.IDATIVO,
                        CA.NRORG,
                        CA.NRORGINCLUSAO,
                        CA.CDOPERINCLUSAO,
                        CA.CDOPERULTATU,
                        CA.NRORGULTATU,
                        CA.DTINCLUSAO,
                        CA.DTULTATU,
                        CA.NRPARCELASMAX,
                        CA.VRPERCMAXATE,
                        OP.NMOPERADOR
                FROM FCT_CARENCIAOPER CA
                JOIN OPERADOR OP ON CA.NRPARCNEGOCIO = OP.NRPARCNEGOCIO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getIdBloq()
    {

        $sql = "SELECT IDBLOQCARENCMAXI
                 FROM FCT_PARAMETROGERAL";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function validaDescontoPeriodoCarenciaOperador($parametros)
    {

        $sql = "SELECT COUNT(*) AS VALIDAOPER
                                      FROM FCT_CARENCIAOPER
                                     WHERE NRPARCNEGOCIO = :NRPARCNEGOCIO
                                     AND NRCARENCIAOPER <> NVL(:NRCARENCIAOPER,-1)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($parametros);
        return $std->fetchAll();
    }

    public function inserirDescontoPeriodoCarenciaOperador($parametros)
    {
        $sql = "INSERT INTO  FCT_CARENCIAOPER (
                    NRCARENCIAOPER, NRPARCNEGOCIO, NRDAISMAXCARENCIA,IDATIVO, NRORG, 
                    NRORGINCLUSAO,CDOPERINCLUSAO, DTINCLUSAO, NRPARCELASMAX,
                    VRPERCMAXATE)
                VALUES (
                    :NRCARENCIAOPER, :NRPARCNEGOCIO, :NRDAISMAXCARENCIA, :IDATIVO,  :NRORG, 
                    :NRORGINCLUSAO,:CDOPERINCLUSAO,SYSDATE, :NRPARCELASMAX, :VRPERCMAXATE
                )";

        $std = $this->connection->prepare($sql);
        $std->execute($parametros);
    }

    public function botaoAtivar($parametros)
    {
        $sql = "UPDATE FCT_PARAMETROGERAL
                   SET IDBLOQCARENCMAXI = :IDBLOQCARENCMAXI";

        $std = $this->connection->prepare($sql);
        $std->execute($parametros);
    }

    public function atualizarDescontoPeriodoCarenciaOperador($parametros)
    {
        $sql = "UPDATE FCT_CARENCIAOPER
                   SET NRPARCNEGOCIO = :NRPARCNEGOCIO,
                       NRDAISMAXCARENCIA = :NRDAISMAXCARENCIA,
                       IDATIVO = :IDATIVO,
                       NRORG = :NRORG,
                       CDOPERULTATU = :CDOPERULTATU,
                       NRORGULTATU = :NRORGULTATU,
                       DTULTATU = SYSDATE,
                       NRPARCELASMAX = :NRPARCELASMAX,
                       VRPERCMAXATE = :VRPERCMAXATE
                WHERE NRCARENCIAOPER = :NRCARENCIAOPER";

        $std = $this->connection->prepare($sql);
        $std->execute($parametros);
    }

    public function deletarDescontoPeriodoCarenciaOperador($parametros)
    {
        $sql = "DELETE FROM FCT_CARENCIAOPER WHERE NRCARENCIAOPER = :NRCARENCIAOPER ";
        $this->connection->executeStatement($sql, $parametros);
    }
}
