<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class Sm00034002DescontoPeriodoCarenciaPerfilAcessoFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getDescontoPeriodoCarenciaPerfilAcesso()
    {
        $sql = "SELECT CA.NRCARENCIAPERFIL,
                       CA.NRPERFILACESSO,
                       CA.NRDAISMAXCARENCIA,
                       CA.IDATIVO,
                       CA.NRORG,
                       CA.NRORGINCLUSAO,
                       CA.CDOPERINCLUSAO,
                       CA.CDOPERULTATU,
                       CA.NRORGULTATU,
                       CA.DTINCLUSAO,
                       CA.DTULTATU,
                       CA.NRPARCELASMAX,
                       CA.VRPERCMAXDE,
                       CA.VRPERCMAXATE,
                       PR.NMPERFILACESSO
                    FROM FCT_CARENCIAPERFIL CA
                    JOIN PERFILACESSO PR ON CA.NRPERFILACESSO = PR.NRPERFILACESSO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function validaDescontoPeriodoCarenciaPerfilAcesso($parametros)
    {
        $sql = "SELECT COUNT(*) AS VALIDAPERF
                  FROM FCT_CARENCIAPERFIL
                 WHERE NRPERFILACESSO = :NRPERFILACESSO
                   AND NRCARENCIAPERFIL <> NVL(:NRCARENCIAPERFIL,-1)";
        
        $std = $this->connection->prepare($sql);
        $std->execute($parametros);
        return $std->fetchAll();
    }

    public function inserirDescontoPeriodoCarenciaPerfilAcesso($parametros)
    {
        $sql = "INSERT INTO  FCT_CARENCIAPERFIL (
                    NRCARENCIAPERFIL, NRPERFILACESSO, NRDAISMAXCARENCIA,IDATIVO, NRORG, 
                    NRORGINCLUSAO,CDOPERINCLUSAO, DTINCLUSAO, NRPARCELASMAX,  VRPERCMAXDE,
                    VRPERCMAXATE)
                VALUES (
                    :NRCARENCIAPERFIL, :NRPERFILACESSO, :NRDAISMAXCARENCIA, :IDATIVO,  :NRORG, 
                    :NRORGINCLUSAO,:CDOPERINCLUSAO,SYSDATE, :NRPARCELASMAX,:VRPERCMAXDE, :VRPERCMAXATE
                )";

        $std = $this->connection->prepare($sql);
        $std->execute($parametros);
    }

    public function atualizarDescontoPeriodoCarenciaPerfilAcesso($parametros)
    {
        $sql = "UPDATE FCT_CARENCIAPERFIL
                   SET NRPERFILACESSO = :NRPERFILACESSO,
                       NRDAISMAXCARENCIA = :NRDAISMAXCARENCIA,
                       IDATIVO = :IDATIVO,
                       NRORG = :NRORG,
                       CDOPERULTATU = :CDOPERULTATU,
                       NRORGULTATU = :NRORGULTATU,
                       DTULTATU = SYSDATE,
                       NRPARCELASMAX = :NRPARCELASMAX,
                       VRPERCMAXDE = :VRPERCMAXDE,
                       VRPERCMAXATE = :VRPERCMAXATE
                 WHERE NRCARENCIAPERFIL = :NRCARENCIAPERFIL";

        $std = $this->connection->prepare($sql);
        $std->execute($parametros);
    }

    public function deletarDescontoPeriodoCarenciaPerfilAcesso($parametros)
    {
        $sql = "DELETE FROM FCT_CARENCIAPERFIL WHERE NRCARENCIAPERFIL = :NRCARENCIAPERFIL";
        $this->connection->executeStatement($sql, $parametros);
    }
}
